%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%for {step}={start}, {1}, {2}, {3}, {4}, {5}, {6}
%
%minimize
%10*pm_pen_g(parameter_alpha1,matrix_new_1)
%pm_pen(parameter_alpha1,matrix_new_0)
%Constraint: <= parameter_alpha_op
%pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))
%Solver: init_point = point_problem_step
%
%end for
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                       Class
%matrix_new_1_data           data        matrix_new_1           10*pm_pen_g(parameter_alpha1,matrix_new_1)          double
%matrix_new_1_vars           vars        matrix_new_1           10*pm_pen_g(parameter_alpha1,matrix_new_1)          cell
%matrix_new_0_data           data        matrix_new_0           pm_pen(parameter_alpha1,matrix_new_0)               double
%matrix_new_0_vars           vars        matrix_new_0           pm_pen(parameter_alpha1,matrix_new_0)               cell
%matrix_0_data               data        matrix_0               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    double
%matrix_0_vars               vars        matrix_0               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    cell
%matrix_1_data               data        matrix_1               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    double
%matrix_1_vars               vars        matrix_1               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    cell
%point_problem_start_data    data        point_problem_start    n/a                                                 double
%point_problem_start_vars    vars        point_problem_start    n/a                                                 cell
%alpha1                      data        parameter_alpha1       10*pm_pen_g(parameter_alpha1,matrix_new_1)          double
%                                                               pm_pen(parameter_alpha1,matrix_new_0)
%alpha2                      data        parameter_alpha2       pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    double
%alpha_op                    data        parameter_alpha_op     Constraint: <= parameter_alpha_op                   double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Classification by Buffered AUC\data_problem_bAUC_3_short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

alpha_op_list = [0.795, 0.785, 0.775, 0.765, 0.755, 0.745, 0.735415];

%Run users m-function Optimization_subroutine:
for i=1:7;
   alpha_op = alpha_op_list(i);
  [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_new_1_data,matrix_new_1_vars,matrix_new_0_data,matrix_new_0_vars,matrix_0_data,matrix_0_vars,matrix_1_data,matrix_1_vars,point_problem_start_data,point_problem_start_vars,alpha1,alpha2,alpha_op);

%Extract Objective:
 val_obj = tbpsg_objective(solution_str, outargstruc_arr);

 disp(' ');
 disp('Objective = ');
 disp(val_obj);

 %Extract optimal solution:
 point_problem_start_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);
 point_problem_start_vars = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);
 
 disp(' ');
 disp('Optimal point = ');
 disp(point_problem_start_data);
end

%Extract structure containing PSG solution reports:
%output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

%disp(' ');
%disp('Structure with PSG solution = ');
%disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
